(function () {
    'use strict';

    angular.module('soter').factory('Picture', ['$resource', Picture]);

    function Picture($resource) {
        return $resource('/v1/picture/:id',
            {id: '@id'}, {
                query: {method: 'GET', params: {list: true}, isArray: true},
                pictures: {method: 'GET', params: {pictures: true}, isArray: true}
            });
    }
})();
