(function () {
    'use strict';

    angular.module('soter').service('Session', Session);

    function Session() {
        this.hasSession = false;
        this.create = function (data) {
            this.id = null;
            this.userId = data.id;
            this.name = data.name;
            this.permissions = data.permissions;
            this.isAuthenticated = data.isAuthenticated;
            this.hasSession = true;
        };
        this.destroy = function () {
            this.id = null;
            this.userId = null;
            this.name = null;
            this.permissions = null;
            this.isAuthenticated = false;
        };
    }
})();

